/// Created by Musa Usman on 14.09.2020
/// Copyright © 2020 Musa Usman. All rights reserved.
///
/// Email: hello@musausman.com
/// Website: musausman.com
/// WhatsApp: +92 324 9066001

class Response<T> {
  T data;
  bool success;

  /// This is the error message which can contain the StackTrace and other error
  /// details that are used for debugging.
  String errorMessage;

  /// This is the error message that can be shown to users.
  String friendlyErrorMessage;

  Response.success(this.data) : this.success = true;

  Response.error(
      {this.errorMessage, this.friendlyErrorMessage = "Something Went Wrong."})
      : this.success = false;

  Response.fromJSON(Map<String, dynamic> response)
      : this.success = response['success'],
        this.data = response['data'],
        this.errorMessage = response['error_message'],
        this.friendlyErrorMessage = response['friendly_error_message'];
}
